;#define PIC16
#define PIC12
#ifdef PIC12
        list      p=12c509            ; list directive to define processor
        #include <p12c509.inc>        ; processor specific variable definitions
        __CONFIG  _CP_OFF & _WDT_ON  & _MCLRE_ON & _IntRC_OSC
bot     equ     7	; 
#endif
#ifdef PIC16
	list      p=16f628            ; list directive to define processor
	#include <p16f628.inc>        ; processor specific variable definitions
	__CONFIG _CP_OFF & _WDT_ON & _BODEN_ON & _PWRTE_ON & _INTRC_OSC_CLKOUT   & _MCLRE_ON & _LVP_OFF
	radix dec
bot     equ     020H	; 
#define GPIO PORTA
#endif

#define CRC FlagBaytSinc
        radix dec

        cblock   bot	
        port            ;     
        Colum   	;  
        Event   	;  
        OldBit  	;  
        Nibl    	; 
        bayt    	; 
        Nbit    	; 
        FlagBaytSinc   	; 
        NBayt   	; 
        temp    	;  
        RxBayt_L        ;  	
        RxBayt_H
	Bufer_M
      	Bufer		; 

        endc



        org 0
        movwf   5       ; 
#ifdef PIC16
	bcf	3,6
	bsf	3,5     ; 1

	movlw	-94     ; TXSTA=0b10100010
	movwf	24	; 


	movlw	25      ;SPBRG=25;
	movwf	25	; 2400

	movlw	3       ; 1:16
	movwf	1	;option=3

	movlw	13      ;
	movwf	5	;TRISA=0x0d;
	clrf	6	;TRISB=0;

	bcf	3,5     ; 0
	
	movlw	-112	;RCSTA=0b10010000;
	movwf	24	; 


	movlw	7       ;CMCON=0x07;
	movwf	31	; 
	

;reader.c: 48: 



#endif 
#ifdef PIC12
        movlw   3
        option
        movlw   13
        tris    6       ;TRIS=0x0d;
#endif
                      
l2                              ; for(;;)
#ifdef PIC12
        bsf     GPIO,5		;test
#endif
#ifdef PIC16
	bsf	PORTB,0		;test
#endif
        movf    GPIO,w          ;  
        andlw   1               ;   
        movwf   temp            ;       temp
        xorwf   port,w          ;   port
        btfss   3,2             ;       
        goto    l5              ; 
        movlw   1               ;  ,
        xorwf   OldBit,f        ; OldBit
        goto    l7
l5
        movf    temp,w          ; 
        movwf   port            ;  port      
l7                              ;   
        movf    GPIO,w          ; 
        andlw   1               ;   
        movwf   temp            ; 
        xorwf   port,w          ;   
        btfss   3,2             ;
        goto    l9              ; 
        clrwdt  
        movlw   61              ; ,   : 
        subwf   1,w     
        btfss   3,0
        goto    l7              ;  ,   
        clrf    FlagBaytSinc    ; ,  
        goto    l7              ; 
l9                              ;  (  )
#ifdef PIC12
        bcf     GPIO,5          ;test     
#endif
#ifdef PIC16
	bcf	PORTB,0
#endif
        movf    temp,w          ;   
        movwf   port            ;  port   
        clrf    1              ; 
;************************
#ifdef PIC12
        btfsc   OldBit,0        ;test  
        bsf     GPIO,4
        btfss   OldBit,0
        bcf     GPIO,4
#endif
#ifdef PIC16
        btfsc   OldBit,0        ;test  
        bsf     PORTB,1
        btfss   OldBit,0
        bcf     PORTB,1
#endif
;************************
        bcf     3,0             ;  
        rlf     RxBayt_L,f      ;
        rlf     RxBayt_H,f      ;
        movf    OldBit,w        ; 
        andlw   1               ;  !
        iorwf   RxBayt_L,f      ;   
        addwf   Event,f         ;   
        incf    Nbit,f          ;  
        btfsc   FlagBaytSinc,0  ;  
        goto    l11             ; 
        bcf     GPIO,1          ; 
;     0x03Fe
        movlw   7               ;     
        andwf   RxBayt_H,f              
        movf    RxBayt_H,w      ;   
        xorlw   3               ;   
        movlw   0FEh            ;   
        btfsc   3,2             ;  ,    
        xorwf   RxBayt_L,w      ;     
        btfss   3,2             ;
        goto    l12             ; ,    :
   	goto	L1              ;, 
l12                             ;    0x0401
        decf    RxBayt_L,w      ;   
        movlw   4               ;  
        btfsc   3,2             ;  ,   
        xorwf   RxBayt_H,w      ; 
        btfss   3,2             ;     
        goto    l73             ; ,  
        movlw   1               ; ,
        xorwf   OldBit,f        ;  !
L1
	bsf     GPIO,1          ;     
        clrf    Nibl            ;     
        clrf    NBayt           ;
        clrf    Event           ;
        clrf    Colum           ;
        movlw   1               ;
        movwf   FlagBaytSinc    ;  
        movwf   Nbit            ;   
        goto    l73             ;  
l11                             ; 
        movf    Nbit,w          ; 
        xorlw   5               ; 5 ? 
        btfss   3,2
        goto    l73             ; ,   
        bcf     3,0             ;5  ,  
        rrf     RxBayt_L,w      ;   
        andlw   15              ;  
        movwf   temp            ;   
        xorwf   Colum,f         ;   
        movf    Nibl,w          ;  
        xorlw   10              ; 10 ?
        btfss   3,2
        goto    l17             ; ,    
        movf    Colum,f         ; 10 ,   
        btfss   3,2
        goto    l69             ;   , 
#ifdef PIC16
	bsf	PORTB,7
#endif

        clrf    CRC             ;  
        movlw   1
        movwf   Bufer         	;Bufer[0]=1
        clrf    NBayt           ;for(NBayt=0;NBayt<7;NBayt++)
l19				;   
        movlw   Bufer		;  
        addwf   NBayt,w         ;    
        movwf   4               ;  FSR
        movf    0,w             ;    
        movwf   bayt            ;bayt=Bufer[NBayt];
;for(temp=8;temp--;)            ;

        movlw   8               ;
        movwf   Nbit            ;
        goto    l25             ;
l22
        movf    CRC,w           ;
        xorwf   bayt,w          ;
        movwf   temp;

        bcf     3,0             ;
        rrf     CRC,w           ;
        btfsc   temp,0          ;if((CRC^bayt)&0x01)
        xorlw   08Ch		;
        movwf   CRC             ;CRC = (CRC>>1)^0x8c;

        bcf     3,0
        rrf     bayt,f          ;bayt>>=1;
l25

        decf    Nbit,f
        incfsz  Nbit,w
        goto    l22

        incf    NBayt,f
        movlw   7
        subwf   NBayt,w
        btfss   3,0
        goto    l19

        movf    CRC,w
        movwf   Bufer+7         ;Bufer[7]=CRC;
        movlw   0FFh
        movwf   Bufer_M           ;Bufer[0-1]=0xff;

;************************************************************************
#ifdef PIC16
	clrf	NBayt         	;for(NBayt=0;NBayt!=9;NBayt++)
l32
;putchar(Bufer[NBayt-1]);
	movf	NBayt,w
	addlw	Bufer_M
	movwf	4
	bcf	3,7
	movf	0,w
	call	putchar
	incf	NBayt,f
	movf	NBayt,w
	xorlw	9
	btfss	3,2
	goto	l32
#endif
;************************************************************************
        clrf    GPIO            ;    GPIO=0
#ifdef PIC16
	bsf	PORTB,6
#endif
l28
        clrwdt 
	btfsc   GPIO,2          ;   
        goto    l28             ;while(GP2==1);

#ifdef PIC16
	bsf	PORTB,5
#endif


l31
        clrwdt 
        btfss   GPIO,2          ;while (GP2==0)
        goto    l31             ;    

#ifdef PIC16
	bsf	PORTB,4
#endif

        movlw   10
        movwf   temp
l37
        decfsz  temp,f
        goto    l37             ; 
        movlw   9		;TRIS=0x09;
#ifdef PIC12
        tris    GPIO               
#endif
#ifdef PIC16
	bsf	3,5
	movwf 	TRISA
	bcf	3,5
#endif

        movlw   100
        movwf   temp
l41
        decfsz  temp,f
        goto    l41             ; 
        movlw   13		;TRIS=0x0d;
#ifdef PIC12
        tris    GPIO               
#endif
#ifdef PIC16
	bsf	3,5
	movwf 	TRISA
	bcf	3,5
#endif
        clrf    NBayt           ;for(NBayt=0;NBayt<9;NBayt++)
l42
        movlw   Bufer_M
        addwf   NBayt,w
        movwf   4
        movf    0,w
        movwf   bayt             ;bayt=Bufer[NBayt-1];
        clrf    Nbit             ;for(Nbit=0;Nbit<8;Nbit++)
l48
        clrwdt  ;#
        btfss   GPIO,2
        goto    l48             ;while(GP2==0)asm(" clrwdt  ");
l52
        clrwdt  ;#
        btfsc   GPIO,2             ;while(GP2==1)
        goto    l52     

        movlw   9
        btfsc   bayt,0          ;if((bayt&0x01)==0) GP2=0
	goto	no_nul
#ifdef PIC12
        tris    GPIO               
#endif
#ifdef PIC16
	bsf	3,5
	movwf 	TRISA
	bcf	3,5
#endif
no_nul
        movlw   12
        movwf   temp
l58
        decfsz  temp,f
        goto    l58             ;

        movlw   13		;TRIS=0x0d;
#ifdef PIC12
        tris    GPIO               
#endif
#ifdef PIC16
	bsf	3,5
	movwf 	TRISA
	bcf	3,5
#endif
        rrf     bayt,f          ;bayt>>=1;
        incf    Nbit,f		; 8 
        movlw   8
        subwf   Nbit,w
        btfss   3,0
        goto    l48

        incf    NBayt,f		;  
        movlw   9
        subwf   NBayt,w
        btfss   3,0
        goto    l42
#ifdef PIC16
	bsf	PORTB,3
#endif

        movlw   7               
#ifdef  PIC12
        option                  ;OPTION=0x07;
#endif
#ifdef	PIC16
	bsf	3,5
	movwf	1
	bcf	3,5
#endif
	movlw	10
        movwf   temp		;  0.7 
l62
        clrwdt  
        incf    1,w             ; while(TMR0!=0xff)
        btfss   3,2
        goto    l62
l66
        clrwdt  
        movf    1,w             ;while(TMR0!=0)
        btfss   3,2
        goto    l66

        decfsz  temp,f
        goto    l62             ;while(--temp);

        movlw   3
#ifdef  PIC12
        option                  ;OPTION=3;
#endif
#ifdef	PIC16
	bsf	3,5
	movwf	1
	bcf	3,5
#endif
        goto    l69		; 
l17
        btfsc   Event,0         ;  
        goto    l69             ; 

        movlw   Bufer           ;
        addwf   NBayt,w         ;  
        movwf   4
        
        btfsc   Nibl,0          ;    ?
        goto    l70             ;   

        swapf   temp,w          ;  
        movwf   0               ;Bufer[NBayt]|=(temp<<4);
        goto    l71
l70                             ;   
        movf    temp,w
        iorwf   0,f
        incf    NBayt,f         ;  
l71
        incf    Nibl,f          ;  
        goto    l68
l69
        clrf    FlagBaytSinc    ;    
l68
        clrf    Nbit            ; -   
l73
	clrwdt	
	movlw	23
	subwf	1,w    
	btfss	3,0
	goto	l73
	goto	l2

#ifdef PIC16
putchar
	movwf	25	;TXREG=c;
	bsf	3,5
wait_tx
	clrwdt	
	btfss	24,1	;while((TXSTA&2)==0)
	goto	wait_tx
	bcf	3,5
	return
#endif
	end
